package com.aware.plugin.beacons.model;

import android.os.Parcelable;
import com.aware.plugin.beacons.util.HexUtils;

import java.text.DecimalFormat;
import java.util.UUID;

public abstract class AbstractBeacon implements Parcelable{

    protected ScanResult scanResult;
    protected double logCurveParameter_A;
    protected double logCurveParameter_b;
    protected double logCurveParameter_n;
    protected double distance;

    public abstract double getRssi();
    public abstract UUID getProximityUUID();
    public abstract int getMajor();
    public abstract int getMinor();
    public abstract int getTxPower();
    public abstract java.lang.String getMacAddress();
    public abstract double getAccuracy();
    public abstract long getTimestamp();
    public abstract String getName();

    public ScanResult getScanResult() {
        return scanResult;
    }

    public void setScanResult(ScanResult scanResult) {
        this.scanResult = scanResult;
    }

    public double getLogCurveParameter_A() {
        return logCurveParameter_A;
    }

    public void setLogCurveParameter_A(double logCurveParameter_A) {
        this.logCurveParameter_A = logCurveParameter_A;
    }

    public double getLogCurveParameter_b() {
        return logCurveParameter_b;
    }

    public void setLogCurveParameter_b(double logCurveParameter_b) {
        this.logCurveParameter_b = logCurveParameter_b;
    }

    public double getLogCurveParameter_n() {
        return logCurveParameter_n;
    }

    public void setLogCurveParameter_n(double logCurveParameter_n) {
        this.logCurveParameter_n = logCurveParameter_n;
    }

    public double getDistance() {
        return distance;
    }

    public void setDistance(double distance) {
        this.distance = distance;
    }

    public int getScanResultRssi(){
        return scanResult.getRssi();
    }

    public byte getTwosComplementOfCalibratedTxPower(){
        return getScanResult().getTwosComplementOfCalibratedTxPower();
    }

    public String toString(){
        return "Proximity UUID: " + getProximityUUID().toString().toUpperCase() +
                " | major: " + HexUtils.intToHexString(getMajor()) +
                " | minor: " + HexUtils.intToHexString(getMinor()) +
                " | rssi: " + Integer.toString(getScanResultRssi()) +
                " | " + Integer.toString(getScanResultRssi() & 0xFF) +
                " | distance: " + new DecimalFormat("#.##").format(getDistance());
    }
}
