package com.aware.plugin.beacons.semweb;

import org.bitbucket.rehei.sparqljava.query.Q;
import org.bitbucket.rehei.sparqljava.query.where;

public class SPARQLQueryCreator {

    public static String tagQuery(final String uuid, final String major, final String minor){

        return Q.prefix("semmap", "http://www.semanticweb.org/agh/wshop/semanticmaps/Concepts#")
                .selectDistinct("?poitag", new where() {
                    {
                        $("?b a semmap:Beacon");
                        $("?b semmap:hasUUID ?uuid");
                        $("?b semmap:hasMajor ?major");
                        $("?b semmap:hasMinor ?minor");
                        $("filter (regex(?uuid, \"" + uuid + "\") && ?major = " + major + " && ?minor = " + minor + ")");
                        $("?b semmap:hasPOI ?poi");
                        $("?poi semmap:hasTag ?poitag");
                    }
                }).get();
    }

    public static String beaconsQuery(final String tag){

        return Q.prefix("semmap", "http://www.semanticweb.org/agh/wshop/semanticmaps/Concepts#")
                .selectDistinct("?uuid ?major ?minor", new where() {
                    {
                        $("?p a semmap:POI");
                        $("?p semmap:hasName ?poiname");
                        $("?p semmap:hasTag ?poitag");
                        $("filter (regex(?poitag, \"" + tag + "\"))");
                        $("?p semmap:isAssignedToBeacon ?b");
                        $("?b semmap:hasUUID ?uuid");
                        $("?b semmap:hasMajor ?major");
                        $("?b semmap:hasMinor ?minor");
                    }
                }).get();
    }
}