package com.aware.plugin.beacons.util;

import java.nio.ByteBuffer;
import java.util.Arrays;

public class HexUtils {

    final protected static char[] hexArray = "0123456789ABCDEF".toCharArray();

    public static String intToHex(int bytes) {
        int v = bytes & 0xFF;
        return String.valueOf(hexArray[v >>> 4]) + String.valueOf(hexArray[v & 0x0F]);
    }

    public static String byteToHex(byte bytes) {
        int v = bytes & 0xFF;
        return String.valueOf(hexArray[v >>> 4]) + String.valueOf(hexArray[v & 0x0F]);
    }

    public static String[] intArrayToHexArray(int[] bytes){
        String[] hex = new String[bytes.length];
        for(int i = 0; i < bytes.length; i++){
            hex[i] = intToHex(bytes[i]);
        }
        return hex;
    }

    public static String[] byteArrayToHexArray(byte[] bytes){
        String[] hex = new String[bytes.length];
        for(int i = 0; i < bytes.length; i++){
            hex[i] = byteToHex(bytes[i]);
        }
        return hex;
    }

    public static String[] intToHexArray(int i){
        byte[] bytes = ByteBuffer.allocate(4).putInt(i).array();
        return byteArrayToHexArray(Arrays.copyOfRange(bytes, 2, 4));
    }

    public static String intToHexString(int i){
        String[] byteStringArray = HexUtils.intToHexArray(i);
        return "" + byteStringArray[0] + byteStringArray[1];
    }
}
