package com.aware.plugin.beacons.view;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import com.aware.Aware;
import com.aware.Aware_Preferences;
import com.aware.plugin.beacons.Constants;

public class BluetoothRequestActivity extends Activity {

    private final static int REQUEST_ENABLE_BT = 1;
    private boolean DEBUG;

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        DEBUG = Aware.getSetting(this.getContentResolver(), Aware_Preferences.DEBUG_FLAG).equals("true");

        Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
        startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if(DEBUG && requestCode == REQUEST_ENABLE_BT) {
            if (resultCode == RESULT_OK) {
                Log.d(Constants.BEACONS_PLUGIN_TAG, "Bluetooth request allowed");
            }else if(resultCode == RESULT_CANCELED){
                Log.d(Constants.BEACONS_PLUGIN_TAG, "Bluetooth request denied");
            }
        }
        this.finish();
    }
}