package com.aware.plugin.beacons.view;

import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import com.aware.Aware;
import com.aware.Aware_Preferences;
import com.aware.plugin.beacons.R;
import com.aware.plugin.beacons.Singleton;
import com.aware.plugin.beacons.model.AbstractBeacon;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import static com.aware.plugin.beacons.Constants.BEACON_MAC_ADDRESS_EXTRA;

public class CalibrationBeaconSelectionActivity extends ActionBarActivity {

    private boolean DEBUG;

    private static final String LIST_KEY = "NAME";

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.calibration_beacon_selection_layout);

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        getSupportActionBar().setTitle("Beacon selection");
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setBackgroundDrawable(new ColorDrawable(Color.rgb(8, 120, 165)));

        DEBUG = Aware.getSetting(getContentResolver(), Aware_Preferences.DEBUG_FLAG).equals("true");

        List<HashMap<String, String>> list = new ArrayList<>();

        for(AbstractBeacon beacon : Singleton.getInstance().getFoundDevices()){
            HashMap<String, String> hm = new HashMap<>();
            hm.put(LIST_KEY, beacon.getMacAddress() + " " + beacon.getName());
            list.add(hm);
        }

        SimpleAdapter simpleListAdapter = new SimpleAdapter(
                this,
                list,
                android.R.layout.simple_list_item_1,
                new String[] {LIST_KEY},
                new int[] { android.R.id.text1}
        );

        ListView listViewBleScanResults = (ListView) findViewById(R.id.calibrationBeaconsList);
        listViewBleScanResults.setAdapter(simpleListAdapter);
        listViewBleScanResults.setClickable(true);
        listViewBleScanResults.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Intent intent = new Intent(CalibrationBeaconSelectionActivity.this, CalibrationProcessActivity.class);
                intent.putExtra(BEACON_MAC_ADDRESS_EXTRA,
                        ((HashMap)parent.getAdapter().getItem(position)).get(LIST_KEY).toString().split(" ")[0]);
                startActivity(intent);
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.empty_menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch(item.getItemId()) {
            case android.R.id.home:
                onBackPressed();
                return true;
        }
        return super.onOptionsItemSelected(item);
    }
}
