package com.aware.plugin.beacons.view;

import android.content.Context;
import android.graphics.Color;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import com.aware.plugin.beacons.R;

import java.util.List;

public class DrawerItemListAdapter extends ArrayAdapter<DrawerItemListAdapter.LabelIconPair> {

    public static class LabelIconPair {

        private String label;
        private String icon ;

        public LabelIconPair(String label, String icon) {
            this.label = label;
            this.icon = icon;
        }
    }

    private List<LabelIconPair> items;

    public DrawerItemListAdapter(Context context, int resource, int textViewResourceId, List<LabelIconPair> items) {
        super(context, resource, textViewResourceId, items);
        this.items = items;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        View view = super.getView(position, convertView, parent);

        TextView textView = (TextView) view.findViewById(android.R.id.text1);

        textView.setText(items.get(position).label);

        ImageView imageView = (ImageView) view.findViewById(R.id.drawer_item_icon);

        if(items.get(position).icon.equals("dark")) {
            switch (position) {
                case 0:
                    imageView.setImageResource(R.drawable.ic_action_bluetooth_dark);
                    break;
                case 1:
                    imageView.setImageResource(R.drawable.ic_action_target_dark);
                    break;
                case 2:
                    imageView.setImageResource(R.drawable.ic_action_map_dark);
                    break;
                case 3:
                    imageView.setImageResource(R.drawable.ic_action_settings_dark);
                    break;
            }
            textView.setTextColor(Color.BLACK);
        }else if(items.get(position).icon.equals("light")) {
            switch (position) {
                case 0:
                    imageView.setImageResource(R.drawable.ic_action_bluetooth_light);
                    break;
                case 1:
                    imageView.setImageResource(R.drawable.ic_action_target_light);
                    break;
                case 2:
                    imageView.setImageResource(R.drawable.ic_action_map_light);
                    break;
                case 3:
                    imageView.setImageResource(R.drawable.ic_action_settings_light);
                    break;
            }
            textView.setTextColor(Color.WHITE);
        }
        return view;
    }

    public int getCount(){
        return items.size();
    }

    public void setItems(List<LabelIconPair> items) {
        this.items = items;
    }
}
