package com.aware.plugin.beacons.view;

import android.content.Context;
import android.content.DialogInterface;
import android.util.AttributeSet;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.TextView;
import com.aware.plugin.beacons.R;

public class EditTextPreference extends android.preference.EditTextPreference {

    public EditTextPreference(Context context) {
        super(context);
        getEditText().setImeOptions(EditorInfo.IME_ACTION_DONE);
    }

    public EditTextPreference(Context context, AttributeSet attrs) {
        super(context, attrs);
        getEditText().setImeOptions(EditorInfo.IME_ACTION_DONE);
    }

    public EditTextPreference(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        getEditText().setImeOptions(EditorInfo.IME_ACTION_DONE);
    }

    @Override
    public void onClick(DialogInterface dialog, int which){
        super.onClick(dialog, which);

        InputMethodManager inputManager = (InputMethodManager) getContext().getSystemService(Context.INPUT_METHOD_SERVICE);
        inputManager.hideSoftInputFromWindow(getEditText().getWindowToken(), 0);
    }
}
