package com.aware.plugin.beacons.view;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.*;
import com.aware.plugin.beacons.R;
import com.aware.plugin.beacons.Singleton;
import com.aware.plugin.beacons.model.AbstractBeacon;
import com.aware.plugin.beacons.model.MockBeacon;

import java.util.List;

public class LeScanResultsListAdapter extends ArrayAdapter<AbstractBeacon> {

    private List<AbstractBeacon> beacons;

    public LeScanResultsListAdapter(Context context, int resource, int textViewResourceId, List<AbstractBeacon> beacons) {
        super(context, resource, textViewResourceId, beacons);
        this.beacons = beacons;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final View view = super.getView(position, convertView, parent);
        TextView text1 = (TextView) view.findViewById(android.R.id.text1);
        TextView text2 = (TextView) view.findViewById(android.R.id.text2);

        text1.setText(beacons.get(position).getMacAddress() + " " + beacons.get(position).getName());
        text2.setText(beacons.get(position).toString());

        if(!(beacons.get(position) instanceof MockBeacon)) {

            final CheckBox checkBox = (CheckBox) view.findViewById(android.R.id.checkbox);

            checkBox.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
                @Override
                public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                    AbstractBeacon beacon = beacons.get(position);
                    if (isChecked) {
                        Singleton.getInstance().addSelectedDevice(beacon);
                    } else {
                        Singleton.getInstance().removeSelectedDevice(beacon);
                    }
                }
            });

            RelativeLayout checkboxLayout = (RelativeLayout) view.findViewById(R.id.checkboxLayout);
            checkboxLayout.setClickable(true);
            checkboxLayout.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (checkBox.isChecked()) {
                        checkBox.setChecked(false);
                    } else {
                        checkBox.setChecked(true);
                    }
                }
            });

            checkBox.setChecked(Singleton.getInstance().getSelectedDevices().contains(beacons.get(position)));
        }

        return view;
    }

    public int getCount(){
        return beacons.size();
    }

    public List<AbstractBeacon> getBeacons() {
        return beacons;
    }
}
