package com.aware.plugin.beacons.view;

import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.preference.*;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.widget.Toolbar;
import android.view.MenuItem;
import com.aware.plugin.beacons.R;
import com.aware.plugin.beacons.Singleton;
import com.aware.plugin.beacons.model.AbstractBeacon;

import static com.aware.plugin.beacons.Constants.BEACON_EXTRA;

public class SettingsActivity extends ActionBarActivity {

    private AbstractBeacon beacon;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);

        setContentView(R.layout.settings_activty_layout);

        AbstractBeacon abstractBeacon = getIntent().getParcelableExtra(BEACON_EXTRA);
        beacon = Singleton.getInstance().getExistingBeacon(abstractBeacon);

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        getSupportActionBar().setTitle("Beacon settings");
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);

        getSupportActionBar().setBackgroundDrawable(new ColorDrawable(Color.rgb(8, 120, 165)));

        getFragmentManager().beginTransaction()
                .replace(R.id.settings_content_frame, new PreferenceFragment() {
                    @Override
                    public void onCreate(Bundle savedInstanceState) {
                        super.onCreate(savedInstanceState);
                        addPreferencesFromResource(R.xml.local_settings);

                        for (int i = 0; i < getPreferenceScreen().getRootAdapter().getCount(); i++) {
                            Object object = getPreferenceScreen().getRootAdapter().getItem(i);
                            if (object instanceof EditTextPreferenceWithValueLocal) {
                                EditTextPreferenceWithValueLocal pref =
                                        (EditTextPreferenceWithValueLocal) object;
                                pref.setBeacon(beacon);
                            }
                        }
                    }
                })
                .commit();
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch(item.getItemId()) {
            case android.R.id.home:
                onBackPressed();
                return true;
        }
        return super.onOptionsItemSelected(item);
    }
}
